/***************************************************************************************************
Unit's Unique Name.h
Purpose: For this particular unit, holds the unique IP addresses for the panel and monitor and
         the unit's name to identify it on the monitor.
Parent:  MicroMatic.c.
***************************************************************************************************/
/*** BeginHeader */


/**************************** Unit's Name **********************************************************
Give the unit a name, which will appear on the monitor(s).  Examples of good names are
"Laser #1", "87R Evaporator Source".  Warning: up to 20 characters only - no checking is done so if
it is longer than 20 bytes it will overwrite some unknown memory space and cause non-deterministic
and likely fatal or even hidden problems! */
#define UNIT_NAME 			"PhotoFinish #1"


/**************************** Unit's TCP/IP Address ************************************************
Give the unit's static IP address.  Examples are "128.100.93.104", "192.168.1.151".  The panel will
use this to control the unit.  Only one panel can connect at a time.  Make sure the address follows
the standard IPv4 four byte format, where each of the four numbers are from 0 to 254. */
#define _PRIMARY_STATIC_IP  "192.168.1.123"


/**************************** Unit's UDP Monitor Address *******************************************
Give the IP address of the monitor(s).  The monitor(s) keep track of how the DDS units are doing,
reporting on when it starts or stops, errors such as loss of lock, etc.  This should be broadcast to
the whole subnet so that any computer on the same subnet can run a monitor, meaning that the last
part should be ".255". Although it is possible to send to any monitor(s) anywhere in the world, the
monitor address should be the same subnet as the unit's IP address.  For example, if the unit's IP
address is 192.168.1.151 then the unit's favoured monitor address would "192.168.1.255".  Note that
the monitor is UDP so that the unit does not care how namy, if any, monitors are listening.  Make
sure the address follows the standard IPv4 four byte format, where each of the first three numbers
are from 0 to 254 and the last byte can be from 1 to 255.  Note that multiple units can share the
same monitor address. */
#define UNIT_MONITOR_ADDRESS 	"192.168.1.255"

/*** EndHeader */
/**************************************************************************************************/

